  MEMBER('eip.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
EIPBC0:DctInit    PROCEDURE
EIPBC0:DctKill    PROCEDURE
EIPBC0:FilesInit  PROCEDURE
  END

Hide:Access:Item     CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Item     CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Config   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Config   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Customer CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:Customer CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:InvDet   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
PrimeAutoInc           PROCEDURE(),BYTE,PROC,DERIVED
ValidateRecord         PROCEDURE(<*UNSIGNED Failed>),BYTE,DERIVED
                     END


Hide:Relate:InvDet   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:InvHdr   CLASS(FileManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


Hide:Relate:InvHdr   CLASS(RelationManager)
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

EIPBC0:DctInit PROCEDURE
  CODE
  Relate:Item &= Hide:Relate:Item
  Relate:Config &= Hide:Relate:Config
  Relate:Customer &= Hide:Relate:Customer
  Relate:InvDet &= Hide:Relate:InvDet
  Relate:InvHdr &= Hide:Relate:InvHdr

EIPBC0:FilesInit PROCEDURE
  CODE
  Hide:Relate:Item.Init
  Hide:Relate:Config.Init
  Hide:Relate:Customer.Init
  Hide:Relate:InvDet.Init
  Hide:Relate:InvHdr.Init


EIPBC0:DctKill PROCEDURE
  CODE
  Hide:Relate:Item.Kill
  Hide:Relate:Config.Kill
  Hide:Relate:Customer.Kill
  Hide:Relate:InvDet.Kill
  Hide:Relate:InvHdr.Kill


Hide:Access:Item.Init PROCEDURE
  CODE
  SELF.Init(Item,GlobalErrors)
  SELF.FileNameValue = 'Item'
  SELF.Buffer &= ITM:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(ITM:ItemIdK,'Item Id Key',1)
  SELF.AddKey(ITM:ItemNumberK,'Item Number Key',0)
  Access:Item &= SELF


Hide:Relate:Item.Init PROCEDURE
  CODE
  Hide:Access:Item.Init
  PARENT.Init(Access:Item,1)


Hide:Access:Item.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Item &= NULL


Hide:Relate:Item.Kill PROCEDURE

  CODE
  Hide:Access:Item.Kill
  PARENT.Kill
  Relate:Item &= NULL


Hide:Access:Config.Init PROCEDURE
  CODE
  SELF.Init(Config,GlobalErrors)
  SELF.FileNameValue = 'Config'
  SELF.Buffer &= CON:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  Access:Config &= SELF


Hide:Relate:Config.Init PROCEDURE
  CODE
  Hide:Access:Config.Init
  PARENT.Init(Access:Config,1)


Hide:Access:Config.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Config &= NULL


Hide:Relate:Config.Kill PROCEDURE

  CODE
  Hide:Access:Config.Kill
  PARENT.Kill
  Relate:Config &= NULL


Hide:Access:Customer.Init PROCEDURE
  CODE
  SELF.Init(Customer,GlobalErrors)
  SELF.FileNameValue = 'Customer'
  SELF.Buffer &= CUS:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(CUS:CustomerIdK,'Customer Id Key',1)
  SELF.AddKey(CUS:NameK,'Customer Name Key',0)
  SELF.AddKey(CUS:NumberK,'Customer Number Key',0)
  Access:Customer &= SELF


Hide:Relate:Customer.Init PROCEDURE
  CODE
  Hide:Access:Customer.Init
  PARENT.Init(Access:Customer,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:InvHdr)


Hide:Access:Customer.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Customer &= NULL


Hide:Relate:Customer.Kill PROCEDURE

  CODE
  Hide:Access:Customer.Kill
  PARENT.Kill
  Relate:Customer &= NULL


Hide:Access:InvDet.Init PROCEDURE
  CODE
  SELF.Init(InvDet,GlobalErrors)
  SELF.FileNameValue = 'InvDet'
  SELF.Buffer &= IND:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(IND:InvDetIdK,'Invoice Detail Id Key',1)
  SELF.AddKey(IND:InvHdrK,'Invoice Header Key',2)
  Access:InvDet &= SELF


Hide:Relate:InvDet.Init PROCEDURE
  CODE
  Hide:Access:InvDet.Init
  PARENT.Init(Access:InvDet,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:InvHdr)


Hide:Access:InvDet.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:InvDet &= NULL


Hide:Access:InvDet.PrimeAutoInc PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.PrimeAutoInc()
  IND:Sequence += (10 - (IND:Sequence % 10))
  RETURN ReturnValue


Hide:Access:InvDet.ValidateRecord PROCEDURE(<*UNSIGNED Failed>)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.ValidateRecord(Failed)
  IF GLO:ValidateRecord
    CASE MESSAGE('Press OK To Simulate Record:OK or CANCEL to simulate Record:Filtered',|
                 'EIP Message Screen',Icon:Exclamation,Button:OK+Button:Cancel,Button:Cancel)
    OF BUTTON:Cancel
      ReturnValue = Record:Filtered
    OF BUTTON:OK
      ReturnValue = Record:OK
    END
  END
  RETURN ReturnValue


Hide:Relate:InvDet.Kill PROCEDURE

  CODE
  Hide:Access:InvDet.Kill
  PARENT.Kill
  Relate:InvDet &= NULL


Hide:Access:InvHdr.Init PROCEDURE
  CODE
  SELF.Init(InvHdr,GlobalErrors)
  SELF.FileNameValue = 'InvHdr'
  SELF.Buffer &= INH:Record
  SELF.Create = 1
  SELF.LockRecover = 10
  SELF.AddKey(INH:InvoiceNumberK,'Invoice Number Key',1)
  SELF.AddKey(INH:InvHdrIdK,'Invoice Header Id Key',1)
  Access:InvHdr &= SELF


Hide:Relate:InvHdr.Init PROCEDURE
  CODE
  Hide:Access:InvHdr.Init
  PARENT.Init(Access:InvHdr,1)
  DO AddRelations_1

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Customer,RI:None,RI:None,CUS:NumberK)
  SELF.AddRelationLink(INH:CustomerNumber,CUS:Number)
  SELF.AddRelation(Relate:InvDet,RI:CASCADE,RI:CASCADE,IND:InvHdrK)
  SELF.AddRelationLink(INH:InvHdrId,IND:InvHdrId)


Hide:Access:InvHdr.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:InvHdr &= NULL


Hide:Relate:InvHdr.Kill PROCEDURE

  CODE
  Hide:Access:InvHdr.Kill
  PARENT.Kill
  Relate:InvHdr &= NULL

