        PROGRAM

        MAP.

    ! MatchEx Tester is Copyright (c) 2001 Carl T. Barnes, Barrington, Illinois, All Rights Reserved
    ! It is free to use but may not be sold and it's source may not be incorporated into products you sell
    !
    ! For a better Regex helper download Clarion Source Search from www.carlbarnes.com
    ! The Regex Assistant is free to use in the unregistered copy.


mText                STRING(160)
TestText             STRING(160),DIM(5)
TestYN               STRING(3),DIM(5)
MatchCase            LONG(1)
MatchType            STRING('2')
MatchSyntax          STRING(500)

!Match:Simple       EQUATE(0)
!Match:Wild         EQUATE(1)
!Match:Regular      EQUATE(2)
!Match:Soundex      EQUATE(3)


Window WINDOW('Match Explorer'),AT(,,319,237),FONT('MS Sans Serif',8,,FONT:regular),ICON(Icon:Thumbnail), |
         SYSTEM,GRAY,DOUBLE
       PANEL,AT(4,4,310,44),USE(?Panel1),BEVEL(-3)
       PROMPT('&Match:'),AT(9,12),USE(?Text:Prompt)
       ENTRY(@s160),AT(41,11,264,12),USE(mText),FONT(,,,FONT:bold)
       STRING('To match Regex Meta Characters .*+?\[]{{}|^$ they must be preceeded by a backslas' &|
           'h'),AT(9,26,298,9),USE(?MetaWarn),TRN
       STRING('For a trailing space on Regex add curly-space-curly {{ } on the end.'),AT(9,35,297,9), |
           USE(?TrailWarn),TRN
       PANEL,AT(4,52,310,92),USE(?Panel2),BEVEL(-3)
       PROMPT('Test &1:'),AT(13,66),USE(?MatchText:Prompt)
       ENTRY(@s160),AT(41,64,231,12),USE(TestText[1]),FONT(,,,FONT:bold)
       PROMPT('Test &2:'),AT(13,81),USE(?MatchText:Prompt:2)
       ENTRY(@s160),AT(41,79,231,12),USE(TestText[2]),FONT(,,,FONT:bold)
       PROMPT('Test &3:'),AT(13,96),USE(?MatchText:Prompt:3)
       ENTRY(@s160),AT(41,94,231,12),USE(TestText[3]),FONT(,,,FONT:bold)
       PROMPT('Test &4:'),AT(13,111),USE(?MatchText:Prompt:4)
       ENTRY(@s160),AT(41,109,231,12),USE(TestText[4]),FONT(,,,FONT:bold)
       PROMPT('Test &5:'),AT(13,126),USE(?MatchText:Prompt:5)
       ENTRY(@s160),AT(41,124,231,12),USE(TestText[5]),FONT(,,,FONT:bold)
       PROMPT('Match?'),AT(279,56),USE(?MatchYN:Prompt),TRN,FONT(,,,FONT:underline)
       STRING(@s3),AT(285,66),USE(TestYN[1]),TRN
       STRING(@s3),AT(285,81),USE(TestYN[2])
       STRING(@s3),AT(285,96),USE(TestYN[3])
       STRING(@s3),AT(285,111),USE(TestYN[4])
       STRING(@s3),AT(285,126),USE(TestYN[5])
       PANEL,AT(5,148,310,36),USE(?Panel3),BEVEL(-3)
       OPTION('Match Type'),AT(11,153,158,26),USE(MatchType),BOXED
         RADIO('Simpl&e'),AT(17,164),USE(?MatchType:Radio:Simple),VALUE('0')
         RADIO('&Wild'),AT(55,164),USE(?MatchType:Radio:Wild),VALUE('1')
         RADIO('&Regex'),AT(85,164),USE(?MatchType:Radio:Regex),VALUE('2')
         RADIO('&Soundex'),AT(123,164),USE(?MatchType:Radio:Soundex),VALUE('3')
       END
       OPTION('&Case Sensitive'),AT(177,153,131,26),USE(MatchCase),BOXED,TIP('Match:NoCase does not work with <13,10>characters inside [sets] so the "Yes" <13,10>option' &|
           ' uses UPPER() on both strings')
         RADIO('&No'),AT(182,164,21,10),USE(?MatchCase:Radio1),TIP('Not Case Sensitive, uses UPPER() on both strings<13,10>to work around Match:NoCase no' &|
             't working in sets')
         RADIO('Match:N&oCase'),AT(207,164,62,10),USE(?MatchCase:Radio3),TIP('Use Match:NoCase which is case sensitive in [Sets]')
         RADIO('&Yes'),AT(273,164,24,10),USE(?MatchCase:Radio2),TIP('Case Sensitive')
       END
       PANEL,AT(5,188,310,43),USE(?Panel4),BEVEL(-3)
       TEXT,AT(11,193,296,33),USE(MatchSyntax),SKIP,FONT(,,,FONT:bold),READONLY
     END
  CODE
  OPEN(Window)

    !--Some sample data
    mText = 'NJ|NY|PA|DE'           !Regex NJ or NY or PA or DE
    TestText[1] = 'IN,OH,KY,TN,PA'
    TestText[2] = 'IN,OH,MI,WI,MN'
    TestText[3] = 'WI,MN,IA,SD,ND'
    TestText[4] = 'VT,NH,MA,NY,RI'

  ACCEPT
    CASE EVENT()
    OF EVENT:Accepted OROF EVENT:OpenWindow
       DO MatchTestRtn
    END
  END
  RETURN
!---------------------------------------------------------------------------

MatchTestRtn    ROUTINE     !To test the Matches
    DATA
Tx      STRING(120),AUTO
TxLen   LONG,AUTO
T       LONG, AUTO
MatchHow   LONG
MatchHowText   PSTRING(20)
    CODE

    CLEAR(TestYN[])
    IF Not mText THEN EXIT.
    Tx = MText
    TxLen = LEN(CLIP(Tx))

    CASE MatchType
    OF Match:Simple
       MatchHow     = Match:Simple
       MatchHowText = 'Match:Simple'
    OF Match:Wild
       MatchHow     = Match:Wild
       MatchHowText = 'Match:Wild'
    OF Match:Soundex
       MatchHow     = Match:Soundex
       MatchHowText = 'Match:Soundex'
    ELSE
       MatchHow     = Match:Regular 
       MatchHowText = 'Match:Regular'
    END

    IF MatchCase = 2
       MatchHow     += Match:NoCase
       MatchHowText = MatchHowText & '+Match:NoCase'
    END

    LOOP T = 1 TO MAXIMUM(TestText[],1)
        IF NOT TestText[T] THEN CYCLE.

        CASE MatchCase
        OF 1
            TestYN[T] = MATCH(UPPER(TestText[T]), UPPER(Tx[1 : TxLen]), MatchHow)
            MatchSyntax = 'MATCH(UPPER(TestString), UPPER(''' & Tx[1 : TxLen] &'''), ' & MatchHowText & ')'
        ELSE
            TestYN[T] = MATCH(TestText[T],              Tx[1 : TxLen],  MatchHow)
            MatchSyntax = 'MATCH(TestString, ''' & Tx[1 : TxLen] &''', ' & MatchHowText & ')'
        END

        CASE TestYN[T]
        OF '1' ; TestYN[T]='Yes'
        OF '0' ; TestYN[T]='No'
        ELSE   ; TestYN[T]='???'
        END

    END

    DISPLAY()

