        PROGRAM

        MAP.

    ! StrPosEx Tester is Copyright (c) 2001 Carl T. Barnes, Barrington, Illinois, All Rights Reserved
    ! It is free to use but may not be sold and it's source may not be incorporated into products you sell
    !
    ! For a better Regex helper download Clarion Source Search from www.carlbarnes.com
    ! The Regex Assistant is free to use in the unregistered copy.

    ! 5.5a
    ! NEW RTL FUNCTIONALITY in StrPOS() - STRPOS() added to BUILTINS.CLW - Support of STRPOS() is added to the evaluator - 
    ! Support of STRPOS() is added to the text editor STRPOS(STRING s,STRING p,BYTE nocase=FALSE),LONG,NAME('Cla$REGULAR') 
    ! Example STRPOS('0123456789','5.*$') should return 6. If regular expression does not match the string, result is 0.


Regex                STRING(160)
TestText             STRING(160),DIM(5)
TestPos               STRING(3),DIM(5)
CaseSensitive            LONG(1)
StrPosSyntax          STRING(500)


Window WINDOW('StrPos Explorer'),AT(,,319,237),FONT('MS Sans Serif',8,,FONT:regular),ICON(Icon:Thumbnail), |
         SYSTEM,GRAY,DOUBLE
       PANEL,AT(4,4,310,44),USE(?Panel1),BEVEL(-3)
       PROMPT('&Regex:'),AT(9,12),USE(?Text:Prompt)
       ENTRY(@s160),AT(41,11,264,12),USE(Regex),FONT(,,,FONT:bold)
       STRING('To match Regex Meta Characters .*+?\[]{{}|^$ they must be preceeded by a backslas' &|
           'h'),AT(9,26,298,9),USE(?MetaWarn),TRN
       STRING('For a trailing space on Regex add curly-space-curly {{ } on the end.'),AT(9,35,297,9), |
           USE(?TrailWarn),TRN
       PANEL,AT(4,52,310,92),USE(?Panel2),BEVEL(-3)
       PROMPT('Test &1:'),AT(13,66),USE(?MatchText:Prompt)
       ENTRY(@s160),AT(41,64,231,12),USE(TestText[1]),FONT(,,,FONT:bold)
       PROMPT('Test &2:'),AT(13,81),USE(?MatchText:Prompt:2)
       ENTRY(@s160),AT(41,79,231,12),USE(TestText[2]),FONT(,,,FONT:bold)
       PROMPT('Test &3:'),AT(13,96),USE(?MatchText:Prompt:3)
       ENTRY(@s160),AT(41,94,231,12),USE(TestText[3]),FONT(,,,FONT:bold)
       PROMPT('Test &4:'),AT(13,111),USE(?MatchText:Prompt:4)
       ENTRY(@s160),AT(41,109,231,12),USE(TestText[4]),FONT(,,,FONT:bold)
       PROMPT('Test &5:'),AT(13,126),USE(?MatchText:Prompt:5)
       ENTRY(@s160),AT(41,124,231,12),USE(TestText[5]),FONT(,,,FONT:bold)
       PROMPT('StrPos?'),AT(279,56),USE(?MatchYN:Prompt),TRN,FONT(,,,FONT:underline)
       STRING(@s3),AT(285,66),USE(TestPos[1]),TRN
       STRING(@s3),AT(285,81),USE(TestPos[2])
       STRING(@s3),AT(285,96),USE(TestPos[3])
       STRING(@s3),AT(285,111),USE(TestPos[4])
       STRING(@s3),AT(285,126),USE(TestPos[5])
       PANEL,AT(5,148,310,36),USE(?Panel3),BEVEL(-3)
       OPTION('&Case Sensitive'),AT(13,153,131,26),USE(CaseSensitive),BOXED
         RADIO('&Upper'),AT(18,164,36,10),USE(?MatchCase:Radio1),TIP('Not Case Sensitive, uses UPPER() on both strings<13,10>to work around NoCase=True not' &|
             ' working in [sets]')
         RADIO('N&o'),AT(68,164,25,10),USE(?MatchCase:Radio3),TIP('Use NoCase=True which is case sensitive in [Sets]')
         RADIO('&Yes'),AT(106,164,27,10),USE(?MatchCase:Radio2),TIP('Case Sensitive')
       END
       PANEL,AT(5,188,310,43),USE(?Panel4),BEVEL(-3)
       TEXT,AT(11,193,296,33),USE(StrPosSyntax),SKIP,FONT(,,,FONT:bold),READONLY
     END
  CODE
  OPEN(Window)

    !--Some sample data
    Regex = 'NJ|NY|PA|DE'           !Regex NJ or NY or PA or DE
    TestText[1] = 'IN,OH,KY,TN,PA'
    TestText[2] = 'IN,OH,Mi,Wi,MN'
    TestText[3] = 'WI,MN,IA,SD,ND'
    TestText[4] = 'VT,Nh,Ma,NY,RI'

  ACCEPT
    CASE EVENT()
    OF EVENT:Accepted OROF EVENT:OpenWindow
       DO StrPosTestRtn
    END
  END
  RETURN
!---------------------------------------------------------------------------

StrPosTestRtn    ROUTINE     !To test the StrPos
    DATA
Tx      STRING(120),AUTO
TxLen   LONG,AUTO
T       LONG, AUTO
StrPosCase     BYTE
    CODE

    CLEAR(TestPos[])
    IF Not Regex THEN EXIT.
    Tx = Regex
    TxLen = LEN(CLIP(Tx))

    IF CaseSensitive = 2
       StrPosCase=1  
    END

    LOOP T = 1 TO MAXIMUM(TestText[],1)
        IF NOT TestText[T] THEN CYCLE.

        CASE CaseSensitive
        OF 1
            TestPos[T] = STRPOS(UPPER(TestText[T]), UPPER(Tx[1 : TxLen]), StrPosCase)
            StrPosSyntax = 'STRPOS(UPPER(TestString), UPPER(''' & Tx[1 : TxLen] &''')' & ', ' & CHOOSE(StrPosCase,'True','False') & ')'
        ELSE
            TestPos[T] = STRPOS(TestText[T],              Tx[1 : TxLen],  StrPosCase)
            StrPosSyntax = 'STRPOS(TestString, ''' & Tx[1 : TxLen] &'''' & ', ' & CHOOSE(StrPosCase,'True','False') & ')'
        END

    END

    DISPLAY()

