

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EIP001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EIP002.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('EIP003.INC'),ONCE        !Req'd for module callout resolution
                       INCLUDE('EIP004.INC'),ONCE        !Req'd for module callout resolution
                     END


Main PROCEDURE                                        !Generated from procedure template - Frame

FilesOpened          BYTE
DisplayDayString STRING('Sunday   Monday   Tuesday  WednesdayThursday Friday   Saturday ')
DisplayDayText   STRING(9),DIM(7),OVER(DisplayDayString)
AppFrame             APPLICATION('Example EIP Application'),AT(,,396,302),STATUS(-1,80,120,45),SYSTEM,MAX,MAXIMIZE,RESIZE,IMM
                       MENUBAR
                         MENU('&File'),USE(?FileMenu)
                           ITEM('P&rint Setup...'),USE(?PrintSetup),MSG('Setup Printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?Browse)
                           ITEM('&Items'),USE(?BrowseItems)
                           ITEM,SEPARATOR
                           ITEM('&Customers'),USE(?BrowseCustomers)
                           ITEM('&Invoices'),USE(?BrowseInvoices)
                         END
                         MENU('&Window'),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                       TOOLBAR,AT(0,0,,25)
                         BUTTON,AT(5,5,16,14),USE(?Toolbar:Top,Toolbar:Top),DISABLE,FLAT,TIP('Go to the First Page'),ICON('WIZFIRST.gif')
                         BUTTON,AT(21,5,16,14),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,FLAT,TIP('Go to the Prior Page'),ICON('WIZPGUP.gif')
                         BUTTON,AT(37,5,16,14),USE(?Toolbar:Up,Toolbar:Up),DISABLE,FLAT,TIP('Go to the Prior Row'),ICON('WIZUP.gif')
                         BUTTON,AT(53,5,16,14),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,FLAT,TIP('Locate row'),ICON('WIZFIND.gif')
                         BUTTON,AT(69,5,16,14),USE(?Toolbar:Down,Toolbar:Down),DISABLE,FLAT,TIP('Go to the Next Row'),ICON('wizdown.gif')
                         BUTTON,AT(85,5,16,14),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,FLAT,TIP('Go to the Next Page'),ICON('WIZPGdn.gif')
                         BUTTON,AT(101,5,16,14),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,FLAT,TIP('Go to the Last Page'),ICON('wizlast.gif')
                         BUTTON,AT(121,5,16,14),USE(?Toolbar:Select,Toolbar:Select),DISABLE,FLAT,TIP('Select This Row'),ICON('WIZMARK.gif')
                         BUTTON,AT(137,5,16,14),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,FLAT,TIP('Insert a New Row'),ICON('wizins.gif')
                         BUTTON,AT(153,5,16,14),USE(?Toolbar:Change,Toolbar:Change),DISABLE,FLAT,TIP('Edit This Row'),ICON('wizedit.gif')
                         BUTTON,AT(169,5,16,14),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,FLAT,TIP('Delete This Row'),ICON('wizdel.gif')
                         BUTTON,AT(189,5,16,14),USE(?Toolbar:History,Toolbar:History),DISABLE,FLAT,TIP('Previous value'),ICON('wizditto.gif')
                         BUTTON,AT(205,5,16,14),USE(?Toolbar:Help,Toolbar:Help),DISABLE,FLAT,TIP('Get Help'),ICON('wizhelp.gif')
                       END
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()

Menu::FileMenu ROUTINE                                !Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                !Code for menu items on ?EditMenu
Menu::Browse ROUTINE                                  !Code for menu items on ?Browse
  CASE ACCEPTED()
  OF ?BrowseItems
    START(BrowseItems, 25000)
  OF ?BrowseCustomers
    START(BrowseCustomers, 25000)
  OF ?BrowseInvoices
    START(BrowseInvoices, 25000)
  END

ThisWindow.Ask PROCEDURE

  CODE
  IF NOT INRANGE(AppFrame{Prop:Timer},1,100)
    AppFrame{Prop:Timer} = 100
  END
    AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
    AppFrame{Prop:StatusText,4} = FORMAT(CLOCK(),@T4)
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(AppFrame)
  SELF.Opened=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::FileMenu                               !Process menu items on ?FileMenu menu
      DO Menu::EditMenu                               !Process menu items on ?EditMenu menu
      DO Menu::Browse                                 !Process menu items on ?Browse menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF Event:Timer
      AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
      AppFrame{Prop:StatusText,4} = FORMAT(CLOCK(),@T4)
    ELSE
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

