

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EIP004.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EIP006.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowseInvoices PROCEDURE                              !Generated from procedure template - Window

FilesOpened          BYTE
lCustomerName        STRING(30)
BRW1::View:Browse    VIEW(InvHdr)
                       PROJECT(INH:InvoiceNumber)
                       PROJECT(INH:Date)
                       PROJECT(INH:InvHdrId)
                       PROJECT(INH:CustomerNumber)
                       JOIN(CUS:NumberK,INH:CustomerNumber)
                         PROJECT(CUS:Number)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
INH:InvoiceNumber      LIKE(INH:InvoiceNumber)        !List box control field - type derived from field
INH:Date               LIKE(INH:Date)                 !List box control field - type derived from field
lCustomerName          LIKE(lCustomerName)            !List box control field - type derived from local data
INH:InvHdrId           LIKE(INH:InvHdrId)             !Primary key field - type derived from field
CUS:Number             LIKE(CUS:Number)               !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('Invoices on File'),AT(0,0,356,230),FONT('Bookman Old Style',10,,300,CHARSET:ANSI),COLOR(0BAA596H),SYSTEM,GRAY,MDI
                       SHEET,AT(4,8,347,202),USE(?Sheet1)
                         TAB('by Invoice '),USE(?Tab:ByInvoiceNumber)
                         END
                       END
                       PANEL,AT(8,28,339,174),USE(?Panel1),FILL(0937E64H),BEVEL(-2)
                       LIST,AT(15,35,323,158),USE(?List),IMM,HVSCROLL,FONT('Bookman Old Style',10,,,CHARSET:ANSI),COLOR(0F4F9FFH,,0937E64H),MSG('Browsing Records'),ALRT(DownKey),FORMAT('37R(1)|M~Invoice~C(0)@n07@48R(1)|M~Date~C(0)@d2b@120L(2)|M~Customer Name~@s30@'),FROM(Queue:Browse)
                       BUTTON('&Insert'),AT(7,214,41,12),USE(?Insert),FLAT,LEFT,KEY(InsertKey),ICON('wizins.gif')
                       BUTTON('&Change'),AT(48,214,49,12),USE(?Change),FLAT,LEFT,KEY(CtrlEnter),ICON('wizedit.gif'),DEFAULT
                       BUTTON('&Delete'),AT(98,214,43,12),USE(?Delete),FLAT,LEFT,KEY(DeleteKey),ICON('wizdel.gif')
                       BUTTON('&Select'),AT(261,214,47,12),USE(?Select),FLAT,LEFT,KEY(EnterKey),ICON('wizMark.gif')
                       BUTTON('Close'),AT(311,214,40,12),USE(?Close),FLAT,LEFT,ICON('wizcncl.gif')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
HdrList              CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseInvoices')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:InvHdr.Open
  SELF.FilesOpened = True
  HdrList.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:InvHdr,SELF)
  OPEN(BrowseWindow)
  SELF.Opened=True
  HdrList.Q &= Queue:Browse
  HdrList.AddSortOrder(,INH:InvoiceNumberK)
  HdrList.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,INH:InvoiceNumber,1,HdrList)
  BIND('lCustomerName',lCustomerName)
  HdrList.AddField(INH:InvoiceNumber,HdrList.Q.INH:InvoiceNumber)
  HdrList.AddField(INH:Date,HdrList.Q.INH:Date)
  HdrList.AddField(lCustomerName,HdrList.Q.lCustomerName)
  HdrList.AddField(INH:InvHdrId,HdrList.Q.INH:InvHdrId)
  HdrList.AddField(CUS:Number,HdrList.Q.CUS:Number)
  HdrList.AskProcedure = 1
  HdrList.AddToolbarTarget(Toolbar)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:InvHdr.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EditHeader
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


HdrList.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


HdrList.SetQueueRecord PROCEDURE

  CODE
  CUS:Number = INH:CustomerNumber
  Access:Customer.Fetch(CUS:NumberK)
  lCustomerName = CUS:Name
  PARENT.SetQueueRecord

