   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('EQUATES.CLW'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('EIPBC.CLW')
DctInit     PROCEDURE
DctKill     PROCEDURE
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('EIP001.CLW')
Main                   PROCEDURE   !Main Menu
     END
   END

GLO:ValidateRecord BYTE
SilentRunning        BYTE(0)                         !Set true when application is running in silent mode

Item                 FILE,DRIVER('TOPSPEED'),PRE(ITM),BINDABLE,CREATE,THREAD
ItemIdK                  KEY(ITM:ItemId),NOCASE,OPT,PRIMARY
ItemNumberK              KEY(ITM:ItemNumber),NOCASE,OPT
Record                   RECORD,PRE()
ItemId                      LONG
ItemNumber                  STRING(10)
Description                 STRING(30)
Cost                        DECIMAL(7,2)
List                        DECIMAL(7,2)
Sell                        DECIMAL(7,2)
UOM                         STRING(2)
IconFile                    CSTRING(256)
                         END
                     END                       

Config               FILE,DRIVER('TOPSPEED'),PRE(CON),CREATE,BINDABLE,THREAD
Record                   RECORD,PRE()
CompanyName                 STRING(30)
TaxRate                     DECIMAL(4,4)
Address                     STRING(20)
City                        STRING(15)
State                       STRING(2)
Zip                         STRING(10)
Phone                       STRING(10)
                         END
                     END                       

Customer             FILE,DRIVER('TOPSPEED'),PRE(CUS),CREATE,BINDABLE,THREAD
CustomerIdK              KEY(CUS:CustomerId),NOCASE,OPT,PRIMARY
NameK                    KEY(CUS:Name),NOCASE,OPT
NumberK                  KEY(CUS:Number),NOCASE,OPT
Record                   RECORD,PRE()
CustomerId                  LONG
Number                      STRING(4)
Name                        STRING(30)
Address                     STRING(20)
City                        STRING(15)
State                       STRING(2)
Zip                         STRING(10)
Phone                       STRING(10)
Fax                         STRING(10)
TollFree                    STRING(10)
Contact                     STRING(20)
                         END
                     END                       

InvDet               FILE,DRIVER('TOPSPEED'),PRE(IND),CREATE,BINDABLE,THREAD
InvDetIdK                KEY(IND:InvDetId),NOCASE,OPT,PRIMARY
InvHdrK                  KEY(IND:InvHdrId,IND:Sequence),NOCASE,OPT
Record                   RECORD,PRE()
InvDetId                    LONG
InvHdrId                    LONG
ItemNumber                  STRING(10)
Quantity                    LONG
Sequence                    LONG
Cost                        DECIMAL(7,2)
List                        DECIMAL(7,2)
Sell                        DECIMAL(7,2)
Print                       STRING(1)
                         END
                     END                       

InvHdr               FILE,DRIVER('TOPSPEED'),PRE(INH),CREATE,BINDABLE,THREAD
InvoiceNumberK           KEY(INH:InvoiceNumber),NOCASE,OPT
InvHdrIdK                KEY(INH:InvHdrId),NOCASE,OPT,PRIMARY
Record                   RECORD,PRE()
CustomerNumber              STRING(4)
InvHdrId                    LONG
InvoiceNumber               LONG
Date                        LONG
                         END
                     END                       



Access:Item          &FileManager
Relate:Item          &RelationManager
Access:Config        &FileManager
Relate:Config        &RelationManager
Access:Customer      &FileManager
Relate:Customer      &RelationManager
Access:InvDet        &FileManager
Relate:InvDet        &RelationManager
Access:InvHdr        &FileManager
Relate:InvHdr        &RelationManager
FuzzyMatcher         FuzzyClass
GlobalErrors         ErrorClass
INIMgr               INIClass
GlobalRequest        BYTE(0),THREAD
GlobalResponse       BYTE(0),THREAD
VCRRequest           LONG(0),THREAD
lCurrentFDSetting    LONG
lAdjFDSetting        LONG

  CODE
  GlobalErrors.Init
  DctInit
  FuzzyMatcher.Init
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)
  INIMgr.Init('eip.INI')
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill
  FuzzyMatcher.Kill
  DctKill
  GlobalErrors.Kill


